package com.yuandian.dataflow.statemachine;

import java.util.concurrent.Executor;

import org.junit.jupiter.api.Test;

import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.error.RemotingException;
import com.alipay.sofa.jraft.option.CliOptions;
import com.alipay.sofa.jraft.rpc.InvokeCallback;
import com.alipay.sofa.jraft.rpc.impl.BoltRaftRpcFactory;
import com.alipay.sofa.jraft.util.Endpoint;
import com.yuandian.dataflow.statemachine.rpc.SMResponse;
import com.yuandian.dataflow.statemachine.rpc.SyncData;
import com.yuandian.dataflow.statemachine.rpc.TaskState;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class StateMachineTest {
    @Test
    void testOnApply() throws InterruptedException, RemotingException {
        var rpcClient = new BoltRaftRpcFactory().createRpcClient();
        rpcClient.init(new CliOptions());


        var fstate = new TaskState(); 
        var fdata = new SyncData();
        fdata.setTaskState(fstate);

        var leader = new Endpoint("localhost",4441);
        SMResponse resp = (SMResponse)rpcClient.invokeSync(leader, fdata
        , 5000);
        log.info("{}", resp);
        if(  resp != null && !resp.isSuccess()  ) {
            leader = resp.getRedirect().getEndpoint();
            resp = (SMResponse)rpcClient.invokeSync(resp.getRedirect().getEndpoint(), fdata
            , 5000);
            log.info("{}", resp);
        }


        int i = 0 ;
        while(true) {

            var state = new TaskState(); 
            var data = new SyncData();
            data.setTaskState(state);
            
            state.setPeerId( PeerId.parsePeer("localhost:2222") );
            
            state.setTaskQueueSize(i);
            
            var pi = i ;
            i++;
            if (i >= 1000) {
                break;
            }
            rpcClient.invokeAsync(leader, data, new InvokeCallback() {
                @Override
                public void complete(Object result, Throwable err) {
                    // SMResponse resp = (SMResponse)result;
                    log.info("{} {} {}", result, err, pi);
                }

                @Override
                public Executor executor() {
                    return null;
                }
            } , 5000);
        }
    }
}
